]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blame - make.sh
suricata: Change midstream policy to "pass-flow"
[people/pmueller/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
9a7e4d85
PM
2###############################################################################
3# #
4# IPFire.org - A linux based firewall #
89e25656 5# Copyright (C) 2007-2023 IPFire Team <info@ipfire.org> #
9a7e4d85
PM
6# #
7# This program is free software: you can redistribute it and/or modify #
8# it under the terms of the GNU General Public License as published by #
9# the Free Software Foundation, either version 3 of the License, or #
10# (at your option) any later version. #
11# #
12# This program is distributed in the hope that it will be useful, #
13# but WITHOUT ANY WARRANTY; without even the implied warranty of #
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15# GNU General Public License for more details. #
16# #
17# You should have received a copy of the GNU General Public License #
18# along with this program. If not, see <http://www.gnu.org/licenses/>. #
19# #
20###############################################################################
df5e82b3 21
e8ee3199
AF
22NAME="IPFire" # Software name
23SNAME="ipfire" # Short name
d12e3fcd 24# If you update the version don't forget to update backupiso and add it to core update
e36e826a 25VERSION="2.29" # Version number
24dbe4ea 26CORE="185" # Core Level (Filename)
e8ee3199
AF
27SLOGAN="www.ipfire.org" # Software slogan
28CONFIG_ROOT=/var/ipfire # Configuration rootdir
e8ee3199 29MAX_RETRIES=1 # prefetch/check loop
305a7b38 30BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 31KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
32
33# Information from Git
34GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
35GIT_TAG="$(git tag | tail -1)" # Git Tag
36GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 37
b6d47f72 38TOOLCHAINVER=20240210
03ad5f93 39
178eaf31
AF
40# use multicore and max compression
41ZSTD_OPT="-T0 --ultra -22"
d66e6fa8 42
69a6ec55
MT
43###############################################################################
44#
45# Beautifying variables & presentation & input output interface
46#
47###############################################################################
48
f9783277
MT
49# Remember if the shell is interactive or not
50if [ -t 0 ] && [ -t 1 ]; then
51 INTERACTIVE=true
52else
53 INTERACTIVE=false
54fi
55
401a1edc
MT
56# Sets or adjusts pretty formatting variables
57resize_terminal() {
58 ## Screen Dimentions
59 # Find current screen size
60 COLUMNS=$(tput cols)
61
62 # When using remote connections, such as a serial port, stty size returns 0
63 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
64 COLUMNS=80
65 fi
69a6ec55 66
401a1edc
MT
67 # Measurements for positioning result messages
68 OPTIONS_WIDTH=20
69 TIME_WIDTH=12
70 STATUS_WIDTH=8
71 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
72 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
73
e9a57acd
MT
74 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
75 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 76}
69a6ec55 77
401a1edc
MT
78# Initially setup terminal
79resize_terminal
f9783277 80
401a1edc
MT
81# Call resize_terminal when terminal is being resized
82trap "resize_terminal" WINCH
69a6ec55
MT
83
84# Define color for messages
85BOLD="\\033[1;39m"
86DONE="\\033[1;32m"
87SKIP="\\033[1;34m"
88WARN="\\033[1;35m"
89FAIL="\\033[1;31m"
90NORMAL="\\033[0;39m"
91
bcb9dc13 92# New architecture variables
dc7d6b20 93HOST_ARCH="$(uname -m)"
94571564 94
69a6ec55
MT
95PWD=$(pwd)
96BASENAME=$(basename $0)
97
15679d9f
MT
98# Debian specific settings
99if [ ! -e /etc/debian_version ]; then
df5e82b3 100 FULLPATH=`which $0`
15679d9f 101else
df5e82b3
MT
102 if [ -x /usr/bin/realpath ]; then
103 FULLPATH=`/usr/bin/realpath $0`
104 else
105 echo "ERROR: Need to do apt-get install realpath"
106 exit 1
107 fi
15679d9f 108fi
df5e82b3 109
69a6ec55 110# This is the directory where make.sh is in
aecbe123 111export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 112
ebaecf2c
AF
113LOGFILE=$BASEDIR/log/_build.preparation.log
114export LOGFILE
15679d9f 115DIR_CHK=$BASEDIR/cache/check
ebaecf2c 116mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 117
69a6ec55
MT
118system_processors() {
119 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
120}
121
122system_memory() {
123 local key val unit
124
125 while read -r key val unit; do
126 case "${key}" in
127 MemTotal:*)
128 # Convert to MB
129 echo "$(( ${val} / 1024 ))"
130 break
131 ;;
132 esac
133 done < /proc/meminfo
134}
135
136configure_build() {
137 local build_arch="${1}"
138
139 if [ "${build_arch}" = "default" ]; then
140 build_arch="$(configure_build_guess)"
141 fi
142
143 case "${build_arch}" in
144 x86_64)
c1d646bf 145 BUILDTARGET="${build_arch}-pc-linux-gnu"
69a6ec55
MT
146 CROSSTARGET="${build_arch}-cross-linux-gnu"
147 BUILD_PLATFORM="x86"
9ea072e6 148 CFLAGS_ARCH="-m64 -mtune=generic -fcf-protection=full"
69a6ec55
MT
149 ;;
150
69a6ec55 151 aarch64)
c1d646bf 152 BUILDTARGET="${build_arch}-pc-linux-gnu"
69a6ec55
MT
153 CROSSTARGET="${build_arch}-cross-linux-gnu"
154 BUILD_PLATFORM="arm"
dfedf913 155 CFLAGS_ARCH="-mbranch-protection=standard"
69a6ec55
MT
156 ;;
157
161eb15d 158 riscv64)
c1d646bf 159 BUILDTARGET="${build_arch}-pc-linux-gnu"
161eb15d
MT
160 CROSSTARGET="${build_arch}-cross-linux-gnu"
161 BUILD_PLATFORM="riscv"
39f94ee8 162 CFLAGS_ARCH=""
161eb15d
MT
163 ;;
164
69a6ec55
MT
165 *)
166 exiterror "Cannot build for architure ${build_arch}"
167 ;;
168 esac
169
170 # Check if the QEMU helper is available if needed.
171 if qemu_is_required "${build_arch}"; then
172 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
173
174 if [ -n "${qemu_build_helper}" ]; then
175 QEMU_TARGET_HELPER="${qemu_build_helper}"
176 else
177 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
178 fi
179 fi
180
181 BUILD_ARCH="${build_arch}"
182 TOOLS_DIR="/tools_${BUILD_ARCH}"
183
184 # Enables hardening
cecad543 185 HARDENING_CFLAGS="-Wp,-U_FORTIFY_SOURCE -Wp,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -fstack-clash-protection"
69a6ec55 186
1b57f838 187 CFLAGS="-O2 -g0 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
69a6ec55
MT
188 CXXFLAGS="${CFLAGS}"
189
c75e90c8
MT
190 RUSTFLAGS="-Copt-level=3 -Clink-arg=-Wl,-z,relro,-z,now -Ccodegen-units=1 --cap-lints=warn ${RUSTFLAGS_ARCH}"
191
69a6ec55 192 # Determine parallelism
eeee108f 193 # We assume that each process consumes about
297473d5 194 # 128MB of memory. Therefore we find out how
eeee108f 195 # many processes fit into memory.
297473d5 196 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
72c39057 197 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
eeee108f
MT
198
199 local parallelism
200 if [ ${mem_max} -lt ${cpu_max} ]; then
201 parallelism=${mem_max}
202 else
203 parallelism=${cpu_max}
69a6ec55 204 fi
212f17c1 205
eeee108f
MT
206 # Use this as default PARALLELISM
207 DEFAULT_PARALLELISM="${parallelism}"
208
e1616eb4
SS
209 # Limit lauched ninja build jobs to computed parallel value.
210 NINJAJOBS="${parallelism}"
211
212f17c1
MT
212 # Compression parameters
213 # We use mode 8 for reasonable memory usage when decompressing
214 # but with overall good compression
215 XZ_OPT="-8"
216
217 # We try to use as many cores as possible
218 XZ_OPT="${XZ_OPT} -T0"
219
220 # We need to limit memory because XZ uses too much when running
221 # in parallel and it isn't very smart in limiting itself.
222 # We allow XZ to use up to 70% of all system memory.
deffc275 223 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1 224
212f17c1 225 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
226}
227
228configure_build_guess() {
229 case "${HOST_ARCH}" in
87487585
MT
230 x86_64)
231 echo "x86_64"
232 ;;
69a6ec55
MT
233
234 aarch64)
235 echo "aarch64"
236 ;;
237
161eb15d
MT
238 riscv64)
239 echo "riscv64"
240 ;;
241
69a6ec55
MT
242 *)
243 exiterror "Cannot guess build architecture"
244 ;;
245 esac
246}
247
f9783277
MT
248stdumount() {
249 umount $BASEDIR/build/sys 2>/dev/null;
250 umount $BASEDIR/build/dev/shm 2>/dev/null;
251 umount $BASEDIR/build/dev/pts 2>/dev/null;
252 umount $BASEDIR/build/dev 2>/dev/null;
253 umount $BASEDIR/build/proc 2>/dev/null;
254 umount $BASEDIR/build/install/mnt 2>/dev/null;
255 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
256 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
257 umount $BASEDIR/build/usr/src/config 2>/dev/null;
258 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
259 umount $BASEDIR/build/usr/src/html 2>/dev/null;
260 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
261 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 262 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 263 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 264 umount $BASEDIR/build/usr/src 2>/dev/null;
cb658c8c 265 umount $BASEDIR/build/tmp 2>/dev/null;
f9783277
MT
266}
267
f9783277
MT
268format_runtime() {
269 local seconds=${1}
270
271 if [ ${seconds} -ge 3600 ]; then
272 printf "%d:%02d:%02d\n" \
273 "$(( seconds / 3600 ))" \
274 "$(( seconds % 3600 / 60 ))" \
275 "$(( seconds % 3600 % 60 ))"
276 elif [ ${seconds} -ge 60 ]; then
277 printf "%d:%02d\n" \
278 "$(( seconds / 60 ))" \
279 "$(( seconds % 60 ))"
69a6ec55 280 else
f9783277 281 printf "%d\n" "${seconds}"
69a6ec55 282 fi
f9783277 283}
69a6ec55 284
f9783277
MT
285print_line() {
286 local line="$@"
69a6ec55 287
f9783277 288 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
289}
290
f9783277
MT
291_print_line() {
292 local status="${1}"
293 shift
69a6ec55 294
f9783277
MT
295 if ${INTERACTIVE}; then
296 printf "${!status}"
297 fi
69a6ec55 298
f9783277
MT
299 print_line "$@"
300
301 if ${INTERACTIVE}; then
302 printf "${NORMAL}"
303 fi
304}
305
306print_headline() {
307 _print_line BOLD "$@"
69a6ec55
MT
308}
309
f9783277
MT
310print_error() {
311 _print_line FAIL "$@"
312}
313
314print_package() {
315 local name="${1}"
316 shift
69a6ec55 317
f9783277
MT
318 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
319 local options="$@"
320
321 local string="${name}"
322 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
323 string="${string} (${version})"
324 fi
325
326 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 327 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
328}
329
330print_runtime() {
331 local runtime=$(format_runtime $@)
332
333 if ${INTERACTIVE}; then
334 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
335 else
336 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 337 fi
f9783277
MT
338}
339
340print_status() {
341 local status="${1}"
342
343 local color="${!status}"
344
345 if ${INTERACTIVE}; then
346 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
347 else
348 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 349 fi
f9783277 350}
69a6ec55 351
f9783277
MT
352print_build_stage() {
353 print_headline "$@"
354
355 # end line
356 printf "\n"
69a6ec55
MT
357}
358
f9783277
MT
359print_build_summary() {
360 local runtime=$(format_runtime $@)
361
362 print_line "*** Build finished in ${runtime}"
363 print_status DONE
69a6ec55
MT
364}
365
366exiterror() {
367 stdumount
368 for i in `seq 0 7`; do
369 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
370 losetup -d /dev/loop${i} 2>/dev/null
371 fi;
372 done
373
f9783277 374 # Dump logfile
66028310 375 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
376 echo # empty line
377
378 local line
379 while read -r line; do
380 echo " ${line}"
381 done <<< "$(tail -n30 ${LOGFILE})"
382 fi
383
f9783277
MT
384 echo # empty line
385
386 local line
387 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
388 print_error "${line}"
389 print_status FAIL
390 done
391
69a6ec55
MT
392 exit 1
393}
394
aecbe123
MT
395prepareenv() {
396 # Are we running the right shell?
54328605 397 if [ -z "${BASH}" ]; then
aecbe123
MT
398 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
399 fi
400
401 if [ -z "${BASH_VERSION}" ]; then
402 exiterror "Not running BASH shell."
403 fi
404
405 # Trap on emergency exit
db9ba592 406 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGQUIT
aecbe123 407
aecbe123 408 # Checking if running as root user
658232a6 409 if [ $(id -u) -ne 0 ]; then
df7f30a1 410 exiterror "root privileges required for building"
aecbe123
MT
411 fi
412
413 # Checking for necessary temporary space
f9783277 414 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
415 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
416 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
417 if (( 2048000 > $BASE_ASPACE )); then
418 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
419 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 420 print_status FAIL
aecbe123
MT
421 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
422 fi
423 else
f9783277 424 print_status DONE
aecbe123
MT
425 fi
426
427 # Set umask
428 umask 022
429
430 # Set LFS Directory
431 LFS=$BASEDIR/build
432
aecbe123
MT
433 # Setup environment
434 set +h
435 LC_ALL=POSIX
e1616eb4 436 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
aecbe123
MT
437 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
438
439 # Make some extra directories
440 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
441 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
442 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
380aa6e5 443 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
7c984de6
MT
444
445 if [ "${ENABLE_RAMDISK}" = "on" ]; then
446 mkdir -p $BASEDIR/build/usr/src
815ca15d 447 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
448
449 mkdir -p ${BASEDIR}/build/tmp
450 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
451 fi
452
ebaecf2c 453 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
454
455 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
456 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
457
458 # Make all sources and proc available under lfs build
459 mount --bind /dev $BASEDIR/build/dev
460 mount --bind /dev/pts $BASEDIR/build/dev/pts
461 mount --bind /dev/shm $BASEDIR/build/dev/shm
462 mount --bind /proc $BASEDIR/build/proc
463 mount --bind /sys $BASEDIR/build/sys
464 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
380aa6e5 465 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
aecbe123
MT
466 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
467 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
468 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
469 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
470 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 471 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
472 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
473
474 # Run LFS static binary creation scripts one by one
475 export CCACHE_DIR=$BASEDIR/ccache
36065e42 476 export CCACHE_TEMPDIR="/tmp"
aecbe123
MT
477 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
478
479 # Remove pre-install list of installed files in case user erase some files before rebuild
480 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
481
482 # Prepare string for /etc/system-release.
f48643e5
MT
483 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
484
485 case "${GIT_BRANCH}" in
486 core*|beta?|rc?)
487 system_release="${system_release} - ${GIT_BRANCH}"
488 ;;
489 *)
9ff65bfa 490 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 491 ;;
aecbe123 492 esac
4e54a8e2 493
f48643e5
MT
494 # Append -dirty tag for local changes
495 if [ "$(git status -s | wc -l)" != "0" ]; then
496 system_release="${system_release}-dirty"
497 fi
498
499 # Export variable
500 SYSTEM_RELEASE="${system_release}"
501
040160c7
MT
502 # Decide on PAKFIRE_TREE
503 case "${GIT_BRANCH}" in
504 core*)
505 PAKFIRE_TREE="stable"
506 ;;
507 master)
508 PAKFIRE_TREE="testing"
509 ;;
510 *)
511 PAKFIRE_TREE="unstable"
512 ;;
513 esac
514
4e54a8e2 515 # Setup ccache cache size
7be78b4c 516 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}"
aecbe123
MT
517}
518
69a6ec55
MT
519enterchroot() {
520 # Install QEMU helper, if needed
521 qemu_install_helper
522
786ed505 523 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin"
69a6ec55 524
19054331
MT
525 # Prepend any custom changes to PATH
526 if [ -n "${CUSTOM_PATH}" ]; then
527 PATH="${CUSTOM_PATH}:${PATH}"
528 fi
529
69a6ec55
MT
530 PATH="${PATH}" chroot ${LFS} env -i \
531 HOME="/root" \
532 TERM="${TERM}" \
533 PS1="${PS1}" \
534 PATH="${PATH}" \
535 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 536 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
537 NAME="${NAME}" \
538 SNAME="${SNAME}" \
539 VERSION="${VERSION}" \
540 CORE="${CORE}" \
541 SLOGAN="${SLOGAN}" \
542 TOOLS_DIR="${TOOLS_DIR}" \
543 CONFIG_ROOT="${CONFIG_ROOT}" \
544 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
545 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 546 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
547 BUILDTARGET="${BUILDTARGET}" \
548 CROSSTARGET="${CROSSTARGET}" \
549 BUILD_ARCH="${BUILD_ARCH}" \
550 BUILD_PLATFORM="${BUILD_PLATFORM}" \
551 CCACHE_DIR=/usr/src/ccache \
36065e42 552 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55 553 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 554 GOCACHE="/usr/src/ccache/go" \
69a6ec55 555 KVER="${KVER}" \
0d7a6f03 556 XZ_OPT="${XZ_OPT}" \
77c863a2 557 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
558 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
559 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
560 $(fake_environ) \
561 $(qemu_environ) \
562 "$@"
563}
564
565entershell() {
566 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
567 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
568 fi
569
570 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 571 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
572
573 if enterchroot bash -i; then
574 stdumount
575 else
f9783277 576 print_status FAIL
69a6ec55
MT
577 exiterror "chroot error"
578 fi
579}
580
581lfsmakecommoncheck() {
582 # Script present?
583 if [ ! -f $BASEDIR/lfs/$1 ]; then
584 exiterror "No such file or directory: $BASEDIR/$1"
585 fi
586
f9783277
MT
587 # Print package name and version
588 print_package $@
69a6ec55
MT
589
590 # Check if this package is supported by our architecture.
591 # If no SUP_ARCH is found, we assume the package can be built for all.
592 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
593 # Check if package supports ${BUILD_ARCH} or all architectures.
594 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 595 print_runtime 0
f9783277 596 print_status SKIP
69a6ec55
MT
597 return 1
598 fi
599 fi
600
601 # Script slipped?
602 local i
603 for i in $SKIP_PACKAGE_LIST
604 do
605 if [ "$i" == "$1" ]; then
f9783277 606 print_status SKIP
69a6ec55
MT
607 return 1;
608 fi
609 done
610
611 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
612
613 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
614 MESSAGE="$1\t " download >> $LOGFILE 2>&1
615 if [ $? -ne 0 ]; then
616 exiterror "Download error in $1"
617 fi
618
619 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
9a7e4d85 620 MESSAGE="$1\t b2sum" b2 >> $LOGFILE 2>&1
69a6ec55 621 if [ $? -ne 0 ]; then
9a7e4d85 622 exiterror "BLAKE2 checksum error in $1, check file in cache or signature"
69a6ec55
MT
623 fi
624
625 return 0 # pass all!
626}
627
628lfsmake1() {
629 lfsmakecommoncheck $*
630 [ $? == 1 ] && return 0
631
1c74bc46
MT
632 # Set PATH to use the toolchain tools first and then whatever the host has set
633 local PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin:${PATH}"
634
0ce11c68 635 if [ -n "${CUSTOM_PATH}" ]; then
1c74bc46 636 PATH="${CUSTOM_PATH}:${PATH}"
0ce11c68
MT
637 fi
638
69a6ec55 639 cd $BASEDIR/lfs && env -i \
0ce11c68 640 PATH="${PATH}" \
4301024b 641 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
36065e42 642 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
643 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
644 CFLAGS="${CFLAGS}" \
645 CXXFLAGS="${CXXFLAGS}" \
77c863a2 646 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
647 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
648 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
649 make -f $* \
650 TOOLCHAIN=1 \
651 TOOLS_DIR="${TOOLS_DIR}" \
652 CROSSTARGET="${CROSSTARGET}" \
653 BUILDTARGET="${BUILDTARGET}" \
654 BUILD_ARCH="${BUILD_ARCH}" \
655 BUILD_PLATFORM="${BUILD_PLATFORM}" \
656 LFS_BASEDIR="${BASEDIR}" \
657 ROOT="${LFS}" \
658 KVER="${KVER}" \
f9783277 659 install >> $LOGFILE 2>&1 &
69a6ec55 660
f9783277
MT
661 if ! wait_until_finished $!; then
662 print_status FAIL
663 exiterror "Building $*"
69a6ec55
MT
664 fi
665
f9783277 666 print_status DONE
69a6ec55
MT
667}
668
669lfsmake2() {
670 lfsmakecommoncheck $*
671 [ $? == 1 ] && return 0
672
69a6ec55
MT
673 local PS1='\u:\w$ '
674
675 enterchroot \
19054331 676 bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
677 make -f $* \
678 LFS_BASEDIR=/usr/src install" \
f9783277 679 >> ${LOGFILE} 2>&1 &
69a6ec55 680
f9783277
MT
681 if ! wait_until_finished $!; then
682 print_status FAIL
683 exiterror "Building $*"
69a6ec55
MT
684 fi
685
f9783277 686 print_status DONE
69a6ec55
MT
687}
688
689ipfiredist() {
690 lfsmakecommoncheck $*
691 [ $? == 1 ] && return 0
692
69a6ec55
MT
693 local PS1='\u:\w$ '
694
695 enterchroot \
696 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 697 >> ${LOGFILE} 2>&1 &
69a6ec55 698
f9783277
MT
699 if ! wait_until_finished $!; then
700 print_status FAIL
701 exiterror "Packaging $*"
702 fi
69a6ec55 703
f9783277
MT
704 print_status DONE
705}
706
707wait_until_finished() {
708 local pid=${1}
709
3080500d 710 local start_time="${SECONDS}"
f9783277
MT
711
712 # Show progress
713 if ${INTERACTIVE}; then
714 # Wait a little just in case the process
715 # has finished very quickly.
716 sleep 0.1
717
718 local runtime
719 while kill -0 ${pid} 2>/dev/null; do
3080500d 720 print_runtime $(( SECONDS - start_time ))
f9783277
MT
721
722 # Wait a little
723 sleep 1
724 done
69a6ec55 725 fi
f9783277
MT
726
727 # Returns the exit code of the child process
728 wait ${pid}
729 local ret=$?
730
731 if ! ${INTERACTIVE}; then
3080500d 732 print_runtime $(( SECONDS - start_time ))
f9783277
MT
733 fi
734
735 return ${ret}
69a6ec55
MT
736}
737
738fake_environ() {
739 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
740
741 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
742
743 # Fake kernel version, because some of the packages do not compile
744 # with kernel 3.0 and later.
8634797e 745 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
746
747 # Fake machine version.
748 env="${env} UTS_MACHINE=${BUILD_ARCH}"
749
750 echo "${env}"
751}
752
753qemu_environ() {
1432531a 754 local env="QEMU_TARGET_HELPER=${QEMU_TARGET_HELPER}"
69a6ec55
MT
755
756 # Don't add anything if qemu is not used.
757 if ! qemu_is_required; then
758 return
759 fi
760
761 # Set default qemu options
762 case "${BUILD_ARCH}" in
763 arm*)
764 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
765
68961fd2
MT
766 env="${env} QEMU_CPU=${QEMU_CPU}"
767 ;;
768 riscv64)
769 QEMU_CPU="${QEMU_CPU:-sifive-u54}"
763301c0
AF
770 G_SLICE="always-malloc"
771 env="${env} QEMU_CPU=${QEMU_CPU} G_SLICE=${G_SLICE}"
69a6ec55
MT
772 ;;
773 esac
774
775 # Enable QEMU strace
776 #env="${env} QEMU_STRACE=1"
777
778 echo "${env}"
779}
780
781qemu_is_required() {
782 local build_arch="${1}"
783
784 if [ -z "${build_arch}" ]; then
785 build_arch="${BUILD_ARCH}"
786 fi
787
788 case "${HOST_ARCH},${build_arch}" in
161eb15d 789 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
69a6ec55
MT
790 return 0
791 ;;
792 *)
793 return 1
794 ;;
795 esac
796}
797
798qemu_install_helper() {
799 # Do nothing, if qemu is not required
800 if ! qemu_is_required; then
801 return 0
802 fi
803
804 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
805 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
806 fi
807
808 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
809 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
810 fi
811
812
813 if [ -z "${QEMU_TARGET_HELPER}" ]; then
814 exiterror "QEMU_TARGET_HELPER not set"
815 fi
816
817 # Check if the helper is already installed.
818 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
819 return 0
820 fi
821
822 # Try to find a suitable binary that we can install
823 # to the build environment.
824 local file
825 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
826 # file must exist and be executable.
827 [ -x "${file}" ] || continue
828
829 # Must be static.
830 file_is_static "${file}" || continue
831
832 local dirname="${LFS}$(dirname "${file}")"
833 mkdir -p "${dirname}"
834
835 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
836 return 0
837 done
838
839 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
840}
841
842qemu_find_build_helper_name() {
843 local build_arch="${1}"
844
845 local magic
846 case "${build_arch}" in
0db0f7fa
AF
847 aarch64)
848 magic="7f454c460201010000000000000000000200b700"
849 ;;
4576ca4c
MT
850 arm*)
851 magic="7f454c4601010100000000000000000002002800"
852 ;;
161eb15d
MT
853 riscv64)
854 magic="7f454c460201010000000000000000000200f300"
855 ;;
69a6ec55
MT
856 x86_64)
857 magic="7f454c4602010100000000000000000002003e00"
858 ;;
859 esac
860
861 [ -z "${magic}" ] && return 1
862
863 local file
864 for file in /proc/sys/fs/binfmt_misc/*; do
865 # skip write only register entry
866 [ $(basename "${file}") = "register" ] && continue
867 # Search for the file with the correct magic value.
868 grep -qE "^magic ${magic}$" "${file}" || continue
869
870 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
871
872 [ -n "${interpreter}" ] || continue
873 [ "${interpreter:0:1}" = "/" ] || continue
874 [ -x "${interpreter}" ] || continue
875
876 echo "${interpreter}"
877 return 0
878 done
879
880 return 1
881}
882
883file_is_static() {
884 local file="${1}"
885
1985774f 886 file -L "${file}" 2>/dev/null | grep -q -e "statically linked" -e "static-pie linked"
69a6ec55
MT
887}
888
889update_language_list() {
890 local path="${1}"
891
892 local lang
893 for lang in ${path}/*.po; do
894 lang="$(basename "${lang}")"
895 echo "${lang%*.po}"
896 done | sort -u > "${path}/LINGUAS"
897}
898
1fb7f56e
MT
899contributors() {
900 local commits name
901
902 git shortlog --summary --numbered | while read -r commits name; do
903 echo "${name}"
904 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
905}
906
907update_contributors() {
908 echo -n "Updating list of contributors"
909
910 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
911
912 # Edit contributors into credits.cgi
e2338aa7
MT
913 local tmp="$(mktemp)"
914
915 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
916 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
917
918 # Copy back modified content
919 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
920 unlink "${tmp}"
1fb7f56e
MT
921
922 print_status DONE
923 return 0
924}
925
15b005d8 926# Default settings
99597de7 927CCACHE_CACHE_SIZE="4G"
15b005d8
MT
928ENABLE_RAMDISK="auto"
929
a98ab1d7
MT
930# Load configuration file
931if [ -f .config ]; then
932 . .config
933fi
934
813659f2
MT
935# TARGET_ARCH is BUILD_ARCH now
936if [ -n "${TARGET_ARCH}" ]; then
937 BUILD_ARCH="${TARGET_ARCH}"
938 unset TARGET_ARCH
939fi
940
85560933
MT
941# Get some information about the host system
942SYSTEM_PROCESSORS="$(system_processors)"
943SYSTEM_MEMORY="$(system_memory)"
944
dc7d6b20
MT
945if [ -n "${BUILD_ARCH}" ]; then
946 configure_build "${BUILD_ARCH}"
949544f5 947else
dc7d6b20 948 configure_build "default"
949544f5
MT
949fi
950
15b005d8
MT
951# Automatically enable/disable ramdisk usage
952if [ "${ENABLE_RAMDISK}" = "auto" ]; then
953 # Enable only when the host system has 4GB of RAM or more
954 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
955 ENABLE_RAMDISK="on"
956 fi
957fi
958
df5e82b3 959buildtoolchain() {
69a6ec55
MT
960 local gcc=$(type -p gcc)
961 if [ -z "${gcc}" ]; then
962 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
963 fi
964
6bd3a131
MT
965 # Check ${TOOLS_DIR} symlink
966 if [ -h "${TOOLS_DIR}" ]; then
967 rm -f "${TOOLS_DIR}"
968 fi
969
970 if [ ! -e "${TOOLS_DIR}" ]; then
971 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
972 fi
973
974 if [ ! -h "${TOOLS_DIR}" ]; then
975 exiterror "Could not create ${TOOLS_DIR} symbolic link"
976 fi
977
ebaecf2c 978 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
979 export LOGFILE
980
981 lfsmake1 stage1
69a6ec55
MT
982 lfsmake1 binutils PASS=1
983 lfsmake1 gcc PASS=1
984 lfsmake1 linux KCFG="-headers"
985 lfsmake1 glibc
178c7a6a 986 lfsmake1 libxcrypt
69a6ec55 987 lfsmake1 gcc PASS=L
54d54148 988 lfsmake1 zlib
7d14c775
MT
989 lfsmake1 binutils PASS=2
990 lfsmake1 gcc PASS=2
0250d332 991 lfsmake1 zstd
74ee1c7a 992 lfsmake1 ccache
69a6ec55
MT
993 lfsmake1 tcl
994 lfsmake1 expect
995 lfsmake1 dejagnu
996 lfsmake1 pkg-config
997 lfsmake1 ncurses
998 lfsmake1 bash
999 lfsmake1 bzip2
1000 lfsmake1 automake
1001 lfsmake1 coreutils
1002 lfsmake1 diffutils
1003 lfsmake1 findutils
1004 lfsmake1 gawk
1005 lfsmake1 gettext
1006 lfsmake1 grep
1007 lfsmake1 gzip
1008 lfsmake1 m4
1009 lfsmake1 make
1010 lfsmake1 patch
1011 lfsmake1 perl
46bbc13b 1012 lfsmake1 python3
69a6ec55
MT
1013 lfsmake1 sed
1014 lfsmake1 tar
1015 lfsmake1 texinfo
1016 lfsmake1 xz
85439ac7 1017 lfsmake1 bison
11b5e5cb 1018 lfsmake1 flex
69a6ec55 1019 lfsmake1 fake-environ
0ce11c68 1020 CUSTOM_PATH="${PATH}" lfsmake1 strip
69a6ec55 1021 lfsmake1 cleanup-toolchain
df5e82b3
MT
1022}
1023
1024buildbase() {
ebaecf2c 1025 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1026 export LOGFILE
1027 lfsmake2 stage2
1028 lfsmake2 linux KCFG="-headers"
1029 lfsmake2 man-pages
1030 lfsmake2 glibc
1031 lfsmake2 tzdata
1032 lfsmake2 cleanup-toolchain
1033 lfsmake2 zlib
b2af45b2 1034 [ "${BUILD_ARCH}" = "riscv64" ] && lfsmake2 gcc PASS=A
8fa66ce7 1035 lfsmake2 zstd
cf6c8e67
MT
1036 lfsmake2 autoconf
1037 lfsmake2 automake
37f48533 1038 lfsmake2 help2man
cf6c8e67 1039 lfsmake2 libtool
69a6ec55
MT
1040 lfsmake2 binutils
1041 lfsmake2 gmp
69a6ec55
MT
1042 lfsmake2 mpfr
1043 lfsmake2 libmpc
cf6c8e67 1044 lfsmake2 libxcrypt
69a6ec55
MT
1045 lfsmake2 file
1046 lfsmake2 gcc
e38fb3f6
MT
1047 lfsmake2 attr
1048 lfsmake2 acl
69a6ec55 1049 lfsmake2 sed
69a6ec55
MT
1050 lfsmake2 berkeley
1051 lfsmake2 coreutils
1052 lfsmake2 iana-etc
1053 lfsmake2 m4
1054 lfsmake2 bison
69a6ec55 1055 lfsmake2 ncurses
69a6ec55
MT
1056 lfsmake2 perl
1057 lfsmake2 readline
69a6ec55 1058 lfsmake2 bzip2
3ece7859 1059 lfsmake2 xz
f407f05a 1060 lfsmake2 lzip
69a6ec55 1061 lfsmake2 pcre
b0c37190 1062 lfsmake2 pcre2
d701756a 1063 lfsmake2 gettext
69a6ec55
MT
1064 lfsmake2 bash
1065 lfsmake2 diffutils
69a6ec55
MT
1066 lfsmake2 ed
1067 lfsmake2 findutils
1068 lfsmake2 flex
1069 lfsmake2 gawk
d2315d00 1070 lfsmake2 go
69a6ec55
MT
1071 lfsmake2 grep
1072 lfsmake2 groff
1073 lfsmake2 gperf
1074 lfsmake2 gzip
1075 lfsmake2 hostname
ac36f9f2 1076 lfsmake2 whois
69a6ec55
MT
1077 lfsmake2 kbd
1078 lfsmake2 less
4720fa0d 1079 lfsmake2 pkg-config
50992c73 1080 lfsmake2 procps
69a6ec55 1081 lfsmake2 make
908a25c6 1082 lfsmake2 libpipeline
69a6ec55 1083 lfsmake2 man
69a6ec55
MT
1084 lfsmake2 net-tools
1085 lfsmake2 patch
1086 lfsmake2 psmisc
1087 lfsmake2 shadow
1088 lfsmake2 sysklogd
1089 lfsmake2 sysvinit
1090 lfsmake2 tar
1091 lfsmake2 texinfo
1092 lfsmake2 util-linux
69a6ec55 1093 lfsmake2 vim
69b3d63b 1094 lfsmake2 e2fsprogs
c9fb8808 1095 lfsmake2 jq
df5e82b3
MT
1096}
1097
15679d9f 1098buildipfire() {
ebaecf2c 1099 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1100 export LOGFILE
489145db
MT
1101 lfsmake2 configroot
1102 lfsmake2 initscripts
1103 lfsmake2 backup
b26cfc2a 1104 lfsmake2 rust
c38f55fe 1105 lfsmake2 openssl
3755e358 1106 lfsmake2 popt
d4767896 1107 lfsmake2 libedit
b6813694
SS
1108 lfsmake2 pam
1109 lfsmake2 libcap
1110 lfsmake2 libcap-ng
489145db
MT
1111 lfsmake2 libpcap
1112 lfsmake2 ppp
1113 lfsmake2 pptp
1114 lfsmake2 unzip
1115 lfsmake2 which
489145db 1116 lfsmake2 bc
489145db 1117 lfsmake2 cpio
de18b4de 1118 lfsmake2 libaio
489145db 1119 lfsmake2 freetype
489145db
MT
1120 lfsmake2 libmnl
1121 lfsmake2 libnfnetlink
1122 lfsmake2 libnetfilter_queue
1123 lfsmake2 libnetfilter_conntrack
1124 lfsmake2 libnetfilter_cthelper
1125 lfsmake2 libnetfilter_cttimeout
1126 lfsmake2 iptables
66bc17dc 1127 lfsmake2 iproute2
0245f3b6 1128 lfsmake2 screen
54ead8ef 1129 lfsmake2 elfutils
62026517
PM
1130 lfsmake2 expat
1131 lfsmake2 libconfig
5a6795f1
AB
1132 lfsmake2 curl
1133 lfsmake2 libarchive
1134 lfsmake2 cmake
62026517
PM
1135 lfsmake2 json-c
1136 lfsmake2 tcl
5b5facc3 1137 lfsmake2 libffi
15e496e4
PM
1138 lfsmake2 gdbm
1139 lfsmake2 sqlite
62026517
PM
1140 lfsmake2 python3
1141 lfsmake2 python3-setuptools
e6453de7 1142 lfsmake2 python3-MarkupSafe
c6b5e0cf 1143 lfsmake2 python3-Jinja2
5b5facc3
MT
1144 lfsmake2 ninja
1145 lfsmake2 meson
b6813694
SS
1146 lfsmake2 kmod
1147 lfsmake2 udev
1148 lfsmake2 libusb
1149 lfsmake2 mdadm
1150 lfsmake2 dracut
1151 lfsmake2 lvm2
1152 lfsmake2 multipath-tools
47a57621
MT
1153 lfsmake2 glib
1154 lfsmake2 libgudev
489145db
MT
1155 lfsmake2 libgpg-error
1156 lfsmake2 libgcrypt
1157 lfsmake2 libassuan
1158 lfsmake2 nettle
3efa7be9 1159 lfsmake2 libsodium
489145db 1160 lfsmake2 libevent2
c8e9a7a8
WA
1161 lfsmake2 apr
1162 lfsmake2 aprutil
489145db
MT
1163 lfsmake2 unbound
1164 lfsmake2 gnutls
689246f5 1165 lfsmake2 libuv
489145db
MT
1166 lfsmake2 bind
1167 lfsmake2 dhcp
1168 lfsmake2 dhcpcd
1169 lfsmake2 boost
1170 lfsmake2 linux-atm
1d66c350 1171 lfsmake2 libqmi
d44ce7d4 1172 lfsmake2 c-ares
321e91cd 1173 lfsmake2 rust-dissimilar
df47bf8b 1174 lfsmake2 rust-cfg-if
4307805f 1175 lfsmake2 rust-libc
6528a858 1176 lfsmake2 rust-getrandom
3062c37a 1177 lfsmake2 rust-typenum
b324df6b 1178 lfsmake2 rust-version-check
25a03398 1179 lfsmake2 rust-generic-array
1e538a2e 1180 lfsmake2 rust-crypto-common
338cde55 1181 lfsmake2 rust-cipher
1485f8d0 1182 lfsmake2 rust-hex
a24ff88b 1183 lfsmake2 rust-unicode-xid
96f567c2 1184 lfsmake2 rust-proc-macro2
87eab5be 1185 lfsmake2 rust-quote
edf4c981 1186 lfsmake2 rust-syn
02c14396 1187 lfsmake2 rust-home
5fab7845 1188 lfsmake2 rust-lazy-static
4349bbe8 1189 lfsmake2 rust-memchr
e5c94bdc 1190 lfsmake2 rust-aho-corasick
f2e7f66b 1191 lfsmake2 rust-regex-syntax
1cf6c790 1192 lfsmake2 rust-regex
ac04ede0 1193 lfsmake2 rust-ucd-trie
2bf0652e 1194 lfsmake2 rust-pest
a93be678 1195 lfsmake2 rust-semver-parser
86c55dbe 1196 lfsmake2 rust-semver
c195a517 1197 lfsmake2 rust-same-file
62d1644d 1198 lfsmake2 rust-walkdir
04a0915d 1199 lfsmake2 rust-dirs
556bd353 1200 lfsmake2 rust-toolchain_find
740d7032 1201 lfsmake2 rust-serde
848a1b01 1202 lfsmake2 rust-itoa
6cb1fb5d 1203 lfsmake2 rust-ryu
3e6bb6f9 1204 lfsmake2 rust-serde_json
9f7a109f 1205 lfsmake2 rust-synstructure
bf75fa26 1206 lfsmake2 rust-block-buffer
eb3db041 1207 lfsmake2 rust-digest
8d6764bb 1208 lfsmake2 rust-ppv-lite86
3851d787 1209 lfsmake2 rust-rand_core
cdcf6935 1210 lfsmake2 rust-rand_core-0.4.2
5df66668 1211 lfsmake2 rust-rand_core-0.3.1
79488e71 1212 lfsmake2 rust-rand_chacha
09b8af02 1213 lfsmake2 rust-rand_hc
8673bd7d 1214 lfsmake2 rust-rand
78914c73 1215 lfsmake2 rust-rdrand
90b6ebe8 1216 lfsmake2 rust-rand-0.4
44dd4dc8 1217 lfsmake2 rust-log
48a3d031 1218 lfsmake2 rust-num_cpus
52a14fbc 1219 lfsmake2 rust-crossbeam-utils
1d6ecb94 1220 lfsmake2 rust-autocfg
31f07518 1221 lfsmake2 rust-memoffset
b0d980bf 1222 lfsmake2 rust-scopeguard
519a98ae 1223 lfsmake2 rust-crossbeam-epoch
d7d3de14 1224 lfsmake2 rust-crossbeam-deque
fbf9f8a4 1225 lfsmake2 rust-either
508f56dc 1226 lfsmake2 rust-crossbeam-channel
a99886bc 1227 lfsmake2 rust-rayon-core
e601c0e3 1228 lfsmake2 rust-rayon
d1abeb8e 1229 lfsmake2 rust-remove_dir_all
3749286c 1230 lfsmake2 rust-tempdir
9fff2c63 1231 lfsmake2 rust-glob
f51709b4 1232 lfsmake2 rust-once_cell
e831bad8 1233 lfsmake2 rust-termcolor
e837da22 1234 lfsmake2 rust-toml
deb6672b 1235 lfsmake2 rust-serde_derive
1cdeadd5 1236 lfsmake2 rust-trybuild
216ac337 1237 lfsmake2 rust-unindent
f03b79b1 1238 lfsmake2 rust-proc-macro-hack
4c313740 1239 lfsmake2 rust-indoc-impl
474ee740 1240 lfsmake2 rust-indoc
34ebd4e5 1241 lfsmake2 rust-indoc-0.3.6
a75c2b24 1242 lfsmake2 rust-instant
202602e0 1243 lfsmake2 rust-lock_api
1bd50189 1244 lfsmake2 rust-smallvec
eda91494 1245 lfsmake2 rust-parking_lot_core
d9c87622 1246 lfsmake2 rust-parking_lot
92ef3020 1247 lfsmake2 rust-paste-impl
f72d049d 1248 lfsmake2 rust-paste
34ebd4e5 1249 lfsmake2 rust-paste-0.1.18
d6f294fb 1250 lfsmake2 rust-ctor
b6c8f86e 1251 lfsmake2 rust-ghost
90490f88 1252 lfsmake2 rust-inventory-impl
3f0d5d36 1253 lfsmake2 rust-inventory
68051dc5 1254 lfsmake2 rust-pyo3-build-config
d2bd4114 1255 lfsmake2 rust-pyo3-macros-backend
b870fa68 1256 lfsmake2 rust-pyo3-macros
fb28b637 1257 lfsmake2 rust-pyo3
34ebd4e5
AB
1258 lfsmake2 rust-num-traits
1259 lfsmake2 rust-num-integer
1260 lfsmake2 rust-num_threads
1261 lfsmake2 rust-time
50274d92 1262 lfsmake2 rust-iana-time-zone
34ebd4e5
AB
1263 lfsmake2 rust-chrono
1264 lfsmake2 rust-asn1_derive
1265 lfsmake2 rust-asn1
1266 lfsmake2 rust-proc-macro-error-attr
1267 lfsmake2 rust-proc-macro-error
1268 lfsmake2 rust-Inflector
1269 lfsmake2 rust-ouroboros_macro
1270 lfsmake2 rust-aliasable
1271 lfsmake2 rust-stable_deref_trait
1272 lfsmake2 rust-ouroboros
1273 lfsmake2 rust-base64
1274 lfsmake2 rust-pem
8a4495a4 1275 lfsmake2 gdb
b3ce3510 1276 lfsmake2 grub
f7384566 1277 lfsmake2 mandoc
b3ce3510
MT
1278 lfsmake2 efivar
1279 lfsmake2 efibootmgr
40cdf896
AB
1280 lfsmake2 libtasn1
1281 lfsmake2 p11-kit
489145db
MT
1282 lfsmake2 ca-certificates
1283 lfsmake2 fireinfo
1284 lfsmake2 libnet
489145db
MT
1285 lfsmake2 libnl-3
1286 lfsmake2 libidn
1287 lfsmake2 nasm
1288 lfsmake2 libjpeg
58d965fe 1289 lfsmake2 openjpeg
489145db
MT
1290 lfsmake2 libexif
1291 lfsmake2 libpng
1292 lfsmake2 libtiff
489145db 1293 lfsmake2 gd
489145db
MT
1294 lfsmake2 slang
1295 lfsmake2 newt
1296 lfsmake2 libsmooth
489145db
MT
1297 lfsmake2 pciutils
1298 lfsmake2 usbutils
1299 lfsmake2 libxml2
1300 lfsmake2 libxslt
3ad4e756 1301 lfsmake2 perl-BerkeleyDB
489145db
MT
1302 lfsmake2 cyrus-sasl
1303 lfsmake2 openldap
1304 lfsmake2 apache2
489145db
MT
1305 lfsmake2 web-user-interface
1306 lfsmake2 flag-icons
1307 lfsmake2 jquery
6033b271 1308 lfsmake2 bootstrap
489145db
MT
1309 lfsmake2 arping
1310 lfsmake2 beep
1df47cc9 1311 lfsmake2 libssh
ff075def 1312 lfsmake2 libinih
8a960584 1313 lfsmake2 cdrkit
489145db 1314 lfsmake2 dosfstools
574690dc 1315 lfsmake2 exfatprogs
489145db 1316 lfsmake2 reiserfsprogs
14192b69 1317 lfsmake2 liburcu
489145db
MT
1318 lfsmake2 xfsprogs
1319 lfsmake2 sysfsutils
1320 lfsmake2 fuse
1321 lfsmake2 ntfs-3g
1322 lfsmake2 ethtool
489145db 1323 lfsmake2 fcron
3ad4e756 1324 lfsmake2 perl-ExtUtils-PkgConfig
489145db 1325 lfsmake2 perl-GD
3ad4e756
AB
1326 lfsmake2 perl-GD-Graph
1327 lfsmake2 perl-GD-TextUtil
489145db
MT
1328 lfsmake2 perl-Device-SerialPort
1329 lfsmake2 perl-Device-Modem
1330 lfsmake2 perl-Apache-Htpasswd
bbcaca56 1331 lfsmake2 perl-Parse-Yapp
46426b69 1332 lfsmake2 perl-Data-UUID
141dd0d7 1333 lfsmake2 perl-Try-Tiny
3234da24 1334 lfsmake2 perl-HTTP-Message
26d87a84 1335 lfsmake2 perl-HTTP-Date
489145db
MT
1336 lfsmake2 gnupg
1337 lfsmake2 hdparm
489145db 1338 lfsmake2 whatmask
29370584 1339 lfsmake2 libtirpc
489145db 1340 lfsmake2 conntrack-tools
489145db
MT
1341 lfsmake2 iputils
1342 lfsmake2 l7-protocols
489145db
MT
1343 lfsmake2 hwdata
1344 lfsmake2 logrotate
1345 lfsmake2 logwatch
1346 lfsmake2 misc-progs
1347 lfsmake2 nano
3ad4e756 1348 lfsmake2 perl-URI
294aa009
AF
1349 lfsmake2 perl-CGI
1350 lfsmake2 perl-Switch
3ad4e756
AB
1351 lfsmake2 perl-HTML-Tagset
1352 lfsmake2 perl-HTML-Parser
1353 lfsmake2 perl-HTML-Template
1354 lfsmake2 perl-Compress-Zlib
1355 lfsmake2 perl-Digest
1356 lfsmake2 perl-Digest-SHA1
1357 lfsmake2 perl-Digest-HMAC
1358 lfsmake2 perl-libwww
9a7e4d85 1359 lfsmake2 perl-LWP-Protocol-https
2f8ff4e8 1360 lfsmake2 perl-Net-HTTP
3ad4e756
AB
1361 lfsmake2 perl-Net-DNS
1362 lfsmake2 perl-Net-IPv4Addr
1363 lfsmake2 perl-Net_SSLeay
1364 lfsmake2 perl-IO-Stringy
1365 lfsmake2 perl-IO-Socket-SSL
1366 lfsmake2 perl-Unix-Syslog
1367 lfsmake2 perl-Mail-Tools
1368 lfsmake2 perl-MIME-Tools
1369 lfsmake2 perl-Net-Server
1370 lfsmake2 perl-Canary-Stability
1371 lfsmake2 perl-Convert-TNEF
1372 lfsmake2 perl-Convert-UUlib
1373 lfsmake2 perl-Archive-Tar
1374 lfsmake2 perl-Archive-Zip
1375 lfsmake2 perl-Text-Tabs+Wrap
1376 lfsmake2 perl-XML-Parser
1377 lfsmake2 perl-Crypt-PasswdMD5
1378 lfsmake2 perl-Net-Telnet
7b5f057a 1379 lfsmake2 perl-JSON
cf94463c 1380 lfsmake2 perl-Capture-Tiny
c8540761 1381 lfsmake2 perl-Config-AutoConf
d33b29e2 1382 lfsmake2 perl-Object-Tiny
2ef62acc 1383 lfsmake2 perl-Archive-Peek-Libarchive
d55a968a 1384 lfsmake2 python3-inotify
05fed717 1385 lfsmake2 python3-docutils
0882b3e4 1386 lfsmake2 python3-daemon
489145db
MT
1387 lfsmake2 ntp
1388 lfsmake2 openssh
1389 lfsmake2 fontconfig
1390 lfsmake2 dejavu-fonts-ttf
70f6cba4 1391 lfsmake2 ubuntu-font-family
489145db
MT
1392 lfsmake2 freefont
1393 lfsmake2 pixman
1394 lfsmake2 cairo
0de1daf3
AB
1395 lfsmake2 harfbuzz
1396 lfsmake2 fribidi
489145db
MT
1397 lfsmake2 pango
1398 lfsmake2 rrdtool
489145db 1399 lfsmake2 setup
616395f3 1400 lfsmake2 jansson
91cc908f 1401 lfsmake2 yaml
3498300d 1402 lfsmake2 libhtp
1a5f0649 1403 lfsmake2 colm
2348cfff 1404 lfsmake2 ragel
52ebc66b 1405 lfsmake2 hyperscan
67752a95 1406 lfsmake2 suricata
ef640882 1407 lfsmake2 ids-ruleset-sources
4ca678a8 1408 lfsmake2 ipblocklist-sources
489145db
MT
1409 lfsmake2 squid
1410 lfsmake2 squidguard
1411 lfsmake2 calamaris
1412 lfsmake2 tcpdump
1413 lfsmake2 traceroute
1414 lfsmake2 vlan
1415 lfsmake2 wireless
1416 lfsmake2 pakfire
adf3f4f4 1417 lfsmake2 lz4
489145db
MT
1418 lfsmake2 lzo
1419 lfsmake2 openvpn
489145db
MT
1420 lfsmake2 mpage
1421 lfsmake2 dbus
1422 lfsmake2 intltool
1423 lfsmake2 libdaemon
6064cd87 1424 lfsmake2 avahi
489145db 1425 lfsmake2 cups
489145db 1426 lfsmake2 lcms2
56170c2a 1427 lfsmake2 ghostscript
489145db
MT
1428 lfsmake2 qpdf
1429 lfsmake2 poppler
d3dabd4b 1430 lfsmake2 poppler-data
489145db
MT
1431 lfsmake2 cups-filters
1432 lfsmake2 epson-inkjet-printer-escpr
fdf630e8 1433 lfsmake2 cups-pdf
489145db
MT
1434 lfsmake2 foomatic
1435 lfsmake2 hplip
1436 lfsmake2 cifs-utils
1437 lfsmake2 krb5
95849177 1438 lfsmake2 rpcsvc-proto
489145db 1439 lfsmake2 samba
18d000c4 1440 lfsmake2 netatalk
489145db
MT
1441 lfsmake2 sudo
1442 lfsmake2 mc
1443 lfsmake2 wget
1444 lfsmake2 bridge-utils
489145db
MT
1445 lfsmake2 smartmontools
1446 lfsmake2 htop
1447 lfsmake2 chkconfig
1448 lfsmake2 postfix
1449 lfsmake2 fetchmail
489145db 1450 lfsmake2 clamav
294aa009 1451 lfsmake2 perl-NetAddr-IP
489145db
MT
1452 lfsmake2 dma
1453 lfsmake2 alsa
1454 lfsmake2 mpfire
1455 lfsmake2 guardian
1456 lfsmake2 libid3tag
1457 lfsmake2 libmad
1458 lfsmake2 libogg
1459 lfsmake2 libvorbis
489145db
MT
1460 lfsmake2 flac
1461 lfsmake2 lame
41f8d642 1462 lfsmake2 soxr
489145db
MT
1463 lfsmake2 libshout
1464 lfsmake2 xvid
1465 lfsmake2 libmpeg2
489145db
MT
1466 lfsmake2 gnump3d
1467 lfsmake2 rsync
489145db 1468 lfsmake2 rpcbind
14fb55a5 1469 lfsmake2 keyutils
489145db 1470 lfsmake2 nfs
489145db
MT
1471 lfsmake2 ncat
1472 lfsmake2 nmap
489145db
MT
1473 lfsmake2 etherwake
1474 lfsmake2 bwm-ng
1475 lfsmake2 sysstat
489145db
MT
1476 lfsmake2 strongswan
1477 lfsmake2 rng-tools
1478 lfsmake2 lsof
1479 lfsmake2 br2684ctl
489145db 1480 lfsmake2 lm_sensors
25f26fb6 1481 lfsmake2 libstatgrab
489145db
MT
1482 lfsmake2 liboping
1483 lfsmake2 collectd
4742a803
MT
1484 lfsmake2 git
1485 lfsmake2 linux-firmware
1486 lfsmake2 dvb-firmwares
1487 lfsmake2 zd1211-firmware
1488 lfsmake2 rpi-firmware
1489 lfsmake2 intel-microcode
1490 lfsmake2 pcengines-apu-firmware
489145db
MT
1491 lfsmake2 elinks
1492 lfsmake2 igmpproxy
489145db 1493 lfsmake2 opus
50274d92
AB
1494 lfsmake2 python3-toml
1495 lfsmake2 python3-pyproject2setuppy
495cf3e0 1496 lfsmake2 python3-pyparsing
489145db
MT
1497 lfsmake2 spice-protocol
1498 lfsmake2 spice
15c01e30 1499 lfsmake2 sdl2
489145db 1500 lfsmake2 libusbredir
43c3a386 1501 lfsmake2 libseccomp
a98abe92 1502 lfsmake2 libslirp
489145db 1503 lfsmake2 qemu
489145db 1504 lfsmake2 netsnmpd
489145db 1505 lfsmake2 nagios_nrpe
2af354c2 1506 lfsmake2 nagios-plugins
489145db 1507 lfsmake2 icinga
01c2ea6b 1508 lfsmake2 observium-agent
489145db 1509 lfsmake2 ebtables
489145db 1510 lfsmake2 faad2
e91ceed6 1511 lfsmake2 alac
489145db
MT
1512 lfsmake2 ffmpeg
1513 lfsmake2 vdr
1514 lfsmake2 vdr_streamdev
489145db
MT
1515 lfsmake2 vdr_epgsearch
1516 lfsmake2 vdr_dvbapi
1517 lfsmake2 vdr_eepg
1518 lfsmake2 w_scan
66c022d8 1519 lfsmake2 fmt
489145db
MT
1520 lfsmake2 mpd
1521 lfsmake2 libmpdclient
1522 lfsmake2 mpc
985741db 1523 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1524 lfsmake2 perl-Net-SMTP-SSL
1525 lfsmake2 perl-MIME-Base64
1526 lfsmake2 perl-Authen-SASL
1527 lfsmake2 perl-MIME-Lite
1528 lfsmake2 perl-Email-Date-Format
489145db
MT
1529 lfsmake2 vnstat
1530 lfsmake2 iw
1531 lfsmake2 wpa_supplicant
1532 lfsmake2 hostapd
489145db
MT
1533 lfsmake2 syslinux
1534 lfsmake2 tftpd
1535 lfsmake2 cpufrequtils
489145db
MT
1536 lfsmake2 gutenprint
1537 lfsmake2 apcupsd
67fbd255 1538 lfsmake2 fireperf
489145db
MT
1539 lfsmake2 iperf
1540 lfsmake2 iperf3
1541 lfsmake2 7zip
1542 lfsmake2 lynis
489145db
MT
1543 lfsmake2 sshfs
1544 lfsmake2 taglib
489145db
MT
1545 lfsmake2 sslh
1546 lfsmake2 perl-gettext
1547 lfsmake2 perl-Sort-Naturally
1548 lfsmake2 vdradmin
489145db 1549 lfsmake2 perl-DBI
489145db
MT
1550 lfsmake2 perl-DBD-SQLite
1551 lfsmake2 perl-File-ReadBackwards
489145db 1552 lfsmake2 openvmtools
489145db
MT
1553 lfsmake2 joe
1554 lfsmake2 monit
1555 lfsmake2 nut
1556 lfsmake2 watchdog
489145db
MT
1557 lfsmake2 usb_modeswitch
1558 lfsmake2 usb_modeswitch_data
1559 lfsmake2 zerofree
489145db
MT
1560 lfsmake2 minicom
1561 lfsmake2 ddrescue
489145db
MT
1562 lfsmake2 parted
1563 lfsmake2 swig
4c59cad1 1564 lfsmake2 dtc
2a0947f2 1565 lfsmake2 u-boot
489145db 1566 lfsmake2 wireless-regdb
489145db 1567 lfsmake2 ddns
0762a36b 1568 lfsmake2 python3-pycparser
2bc596c6 1569 lfsmake2 python3-charset-normalizer
3992da53 1570 lfsmake2 python3-certifi
a7e60957 1571 lfsmake2 python3-idna
1acceaad 1572 lfsmake2 python3-requests
269ccc44 1573 lfsmake2 python3-tomli
8debeb1d 1574 lfsmake2 python3-pep517
396cbbae 1575 lfsmake2 python3-build
5868a78e 1576 lfsmake2 python3-install
82bd0acc 1577 lfsmake2 python3-urllib3
15293bed 1578 lfsmake2 python3-flit
82bd0acc 1579 lfsmake2 python3-packaging
0d9e06c5 1580 lfsmake2 python3-typing-extensions
bd5d1535 1581 lfsmake2 python3-semantic-version
662b2a81 1582 lfsmake2 python3-setuptools-scm
28dcdc28 1583 lfsmake2 python3-setuptools-rust
5996c281 1584 lfsmake2 python3-six
e0a05a80 1585 lfsmake2 python3-dateutil
d48ea6b5 1586 lfsmake2 python3-jmespath
a33ca4cc 1587 lfsmake2 python3-colorama
d2da17a1 1588 lfsmake2 python3-yaml
953f6f73 1589 lfsmake2 python3-s3transfer
d45d5247 1590 lfsmake2 python3-rsa
faa5472a 1591 lfsmake2 python3-pyasn1
4ab80c5d 1592 lfsmake2 python3-botocore
cdb6d532 1593 lfsmake2 python3-cffi
7c49b087 1594 lfsmake2 python3-cryptography
03d1f485 1595 lfsmake2 python3-circuitbreaker
cb0c310e 1596 lfsmake2 python3-pytz
d92b81e9 1597 lfsmake2 python3-click
91f907df 1598 lfsmake2 python3-arrow
439e713e 1599 lfsmake2 python3-terminaltables
9196f2a4 1600 lfsmake2 python3-pkgconfig
de6ef4d4 1601 lfsmake2 python3-msgpack
ec01213d 1602 lfsmake2 python3-editables
ccaa26aa 1603 lfsmake2 python3-pathspec
cffababa 1604 lfsmake2 python3-pluggy
6c7e8760 1605 lfsmake2 python3-calver
6d7c67de 1606 lfsmake2 python3-trove-classifiers
0f2449af 1607 lfsmake2 python3-hatchling
eadd3ad7 1608 lfsmake2 python3-hatch-vcs
703d5dfe 1609 lfsmake2 python3-hatch-fancy-pypi-readme
85749ec4
AB
1610 lfsmake2 python3-attrs
1611 lfsmake2 python3-sniffio
1612 lfsmake2 python3-sortedcontainers
1613 lfsmake2 python3-outcome
1614 lfsmake2 python3-async_generator
9fe8af10
AB
1615 lfsmake2 python3-flit_scm
1616 lfsmake2 python3-exceptiongroup
85749ec4
AB
1617 lfsmake2 python3-trio
1618 lfsmake2 python3-pyfuse3
280ee7e7 1619 lfsmake2 aws-cli
576c02be 1620 lfsmake2 oci-python-sdk
d6196cdb 1621 lfsmake2 oci-cli
489145db 1622 lfsmake2 transmission
489145db 1623 lfsmake2 mtr
489145db
MT
1624 lfsmake2 minidlna
1625 lfsmake2 acpid
1626 lfsmake2 fping
1627 lfsmake2 telnet
1628 lfsmake2 xinetd
489145db 1629 lfsmake2 stress
489145db 1630 lfsmake2 sarg
489145db 1631 lfsmake2 nginx
489145db
MT
1632 lfsmake2 sysbench
1633 lfsmake2 strace
489145db
MT
1634 lfsmake2 ltrace
1635 lfsmake2 ipfire-netboot
1636 lfsmake2 lcdproc
489145db
MT
1637 lfsmake2 keepalived
1638 lfsmake2 ipvsadm
1639 lfsmake2 perl-Carp-Clan
1640 lfsmake2 perl-Date-Calc
1641 lfsmake2 perl-Date-Manip
1642 lfsmake2 perl-File-Tail
1643 lfsmake2 perl-TimeDate
1644 lfsmake2 swatch
1645 lfsmake2 tor
489145db
MT
1646 lfsmake2 wavemon
1647 lfsmake2 iptraf-ng
1648 lfsmake2 iotop
1649 lfsmake2 stunnel
489145db 1650 lfsmake2 bacula
b62c826f
MT
1651 lfsmake2 perl-Font-TTF
1652 lfsmake2 perl-IO-String
489145db 1653 lfsmake2 perl-PDF-API2
adb4174f 1654 lfsmake2 proxy-accounting
489145db
MT
1655 lfsmake2 tmux
1656 lfsmake2 perl-Text-CSV_XS
09b09b85 1657 lfsmake2 lua
489145db
MT
1658 lfsmake2 haproxy
1659 lfsmake2 ipset
489145db
MT
1660 lfsmake2 dnsdist
1661 lfsmake2 bird
8c855a58 1662 lfsmake2 libyang
e2dce81c
MT
1663 lfsmake2 abseil-cpp
1664 lfsmake2 protobuf
1665 lfsmake2 protobuf-c
1a7db134 1666 lfsmake2 frr
489145db
MT
1667 lfsmake2 dmidecode
1668 lfsmake2 mcelog
489145db
MT
1669 lfsmake2 libpciaccess
1670 lfsmake2 libyajl
1671 lfsmake2 libvirt
42fca290 1672 lfsmake2 libtalloc
489145db
MT
1673 lfsmake2 freeradius
1674 lfsmake2 perl-common-sense
1675 lfsmake2 perl-inotify2
1676 lfsmake2 perl-Net-IP
0d6cc79d 1677 lfsmake2 wio
773caa66 1678 lfsmake2 iftop
ddcd60f7 1679 lfsmake2 mdns-repeater
429af178 1680 lfsmake2 i2c-tools
4e9000b4 1681 lfsmake2 nss-myhostname
014b235a 1682 lfsmake2 dehydrated
200e39b7 1683 lfsmake2 libplist
c4fc6eb0 1684 lfsmake2 nqptp
c708fa15 1685 lfsmake2 shairport-sync
46114d79 1686 lfsmake2 borgbackup
50483167 1687 lfsmake2 lmdb
2397e513 1688 lfsmake2 knot
e1982c69 1689 lfsmake2 spectre-meltdown-checker
06fc6170 1690 lfsmake2 zabbix_agentd
82d176d3 1691 lfsmake2 flashrom
2aca6aa0 1692 lfsmake2 firmware-update
ffcef39d 1693 lfsmake2 tshark
9875e9f2 1694 lfsmake2 speedtest-cli
44cc9a3d 1695 lfsmake2 amazon-ssm-agent
d938509e 1696 lfsmake2 libloc
4d275bcd 1697 lfsmake2 ncdu
76c5f3e0 1698 lfsmake2 lshw
68fbcc0e 1699 lfsmake2 socat
7300386b
AB
1700 lfsmake2 libcdada
1701 lfsmake2 pmacct
2b591415 1702 lfsmake2 squid-asnbl
df0635ab 1703 lfsmake2 qemu-ga
5f8a1acf 1704 lfsmake2 gptfdisk
7e4af6eb 1705 lfsmake2 oath-toolkit
e0fa8c25 1706 lfsmake2 qrencode
6f8b1c53 1707 lfsmake2 perl-File-Remove
a102cdba 1708 lfsmake2 perl-Module-Build
bfc889a7 1709 lfsmake2 perl-Module-ScanDeps
3aeadfd8 1710 lfsmake2 perl-YAML-Tiny
cb36c092 1711 lfsmake2 perl-Module-Install
bc8bea12 1712 lfsmake2 perl-Imager
e97759c2 1713 lfsmake2 perl-Imager-QRCode
dc124917 1714 lfsmake2 perl-MIME-Base32
6a53c26c 1715 lfsmake2 perl-URI-Encode
f23508b7 1716 lfsmake2 rsnapshot
9786225a 1717 lfsmake2 mympd
605217e9 1718 lfsmake2 wsdd
45c75a55
AF
1719
1720 # Kernelbuild ... current we have no platform that need
1721 # multi kernel builds so KCFG is empty
1722 lfsmake2 linux KCFG=""
45c75a55 1723 lfsmake2 rtl8812au KCFG=""
45c75a55 1724 lfsmake2 linux-initrd KCFG=""
d0817963 1725}
df5e82b3
MT
1726
1727buildinstaller() {
1728 # Run installer scripts one by one
ebaecf2c 1729 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1730 export LOGFILE
489145db
MT
1731 lfsmake2 memtest
1732 lfsmake2 installer
ce9264a1 1733 # use toolchain bash for chroot to strip
19054331 1734 CUSTOM_PATH="${TOOLS_DIR}/bin" lfsmake2 strip
df5e82b3
MT
1735}
1736
1737buildpackages() {
ebaecf2c 1738 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1739 export LOGFILE
1740 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1741
2f8ae1c2 1742
df5e82b3 1743 # Generating list of packages used
dc4ae0b7 1744 print_line "Generating packages list from logs"
df5e82b3 1745 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1746 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1747 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1748 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1749 fi
1750 done
7471f6ab 1751 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1752 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1753 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1754 rm -f $BASEDIR/doc/packages-list
c9673262 1755 # packages-list.txt is ready to be displayed for wiki page
f9783277 1756 print_status DONE
2f8ae1c2 1757
4b06f504 1758 # Update changelog
e49f7f0d 1759 cd $BASEDIR
c43b07fd
AF
1760 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1761 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1762 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1763
9607771a 1764 # Create images for install
489145db 1765 lfsmake2 cdrom
bada0832 1766
4dc82852 1767 # Check if there is a loop device for building in virtual environments
841663e7
MT
1768 modprobe loop 2>/dev/null
1769 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1770 lfsmake2 flash-images
4dc82852 1771 fi
c9673262 1772
c4dd9dfc 1773 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1774
0d909a4a 1775 ipfirepackages
e67a57fe 1776
b307417f 1777 cd $BASEDIR
744a04ea 1778
5336aaa6 1779 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
9a7e4d85 1780 b2sum $i > $i.b2
b307417f
AF
1781 done
1782 cd $PWD
1783
e67a57fe
MT
1784 # Cleanup
1785 stdumount
1786 rm -rf $BASEDIR/build/tmp/*
1787
e67a57fe 1788 cd $PWD
e67a57fe
MT
1789}
1790
1791ipfirepackages() {
489145db 1792 lfsmake2 core-updates
5596077b
MT
1793
1794 local i
dc7d6b20 1795 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1796 i=$(basename ${i})
453b418b
MT
1797 if [ -e $BASEDIR/lfs/$i ]; then
1798 ipfiredist $i
1799 else
1800 echo -n $i
f9783277 1801 print_status SKIP
453b418b 1802 fi
fe7fe395 1803 done
78331e30 1804 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1805 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1806 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1807}
1808
bcb9dc13
MT
1809while [ $# -gt 0 ]; do
1810 case "${1}" in
1811 --target=*)
c2e810de 1812 configure_build "${1#--target=}"
bcb9dc13
MT
1813 ;;
1814 -*)
1815 exiterror "Unknown configuration option: ${1}"
1816 ;;
1817 *)
1818 # Found a command, so exit options parsing.
1819 break
1820 ;;
1821 esac
1822 shift
1823done
1824
df5e82b3 1825# See what we're supposed to do
2f8ae1c2 1826case "$1" in
df5e82b3 1827build)
3080500d 1828 START_TIME="${SECONDS}"
f9783277 1829
d66e6fa8 1830 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
df5e82b3 1831 #only restore on a clean disk
6c4cc7ea 1832 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1833 if [ ! -n "$PACKAGE" ]; then
f9783277 1834 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1835 prepareenv
1836 buildtoolchain
1837 else
d66e6fa8 1838 PACKAGENAME=${PACKAGE%.tar.zst}
f9783277 1839 print_build_stage "Packaged toolchain compilation"
9a7e4d85 1840 if [ `b2sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.b2 | awk '{print $1}'` ]; then
cec532b4 1841 zstd -d < "${PACKAGE}" | tar x
df5e82b3
MT
1842 prepareenv
1843 else
9a7e4d85 1844 exiterror "$PACKAGENAME BLAKE2 checksum did not match, check downloaded package"
df5e82b3
MT
1845 fi
1846 fi
1847 else
df5e82b3
MT
1848 prepareenv
1849 fi
5cfe86e6 1850
f9783277 1851 print_build_stage "Building LFS"
df5e82b3 1852 buildbase
15679d9f 1853
f9783277 1854 print_build_stage "Building IPFire"
15679d9f 1855 buildipfire
5cfe86e6 1856
f9783277 1857 print_build_stage "Building installer"
df5e82b3 1858 buildinstaller
15679d9f 1859
f9783277 1860 print_build_stage "Building packages"
df5e82b3 1861 buildpackages
2f8ae1c2 1862
f9783277 1863 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1864
1865 cd $BASEDIR
7a5ed24e 1866 tools/checknewlog.pl
e0c923f4 1867 tools/checkrootfiles
b307417f 1868 cd $PWD
a23731d1 1869
3080500d 1870 print_build_summary $(( SECONDS - START_TIME ))
df5e82b3
MT
1871 ;;
1872shell)
1873 # enter a shell inside LFS chroot
1874 # may be used to changed kernel settings
1875 prepareenv
1876 entershell
1877 ;;
df5e82b3 1878clean)
f9783277
MT
1879 print_line "Cleaning build directory..."
1880
df5e82b3
MT
1881 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1882 $LOSETUP -d $i 2>/dev/null
1883 done
b0c37190
MT
1884 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1885 # umount $i
1886 #done
df5e82b3
MT
1887 stdumount
1888 for i in `seq 0 7`; do
69a6ec55 1889 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1890 umount /dev/loop${i} 2>/dev/null;
1891 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1892 fi;
df5e82b3
MT
1893 done
1894 rm -rf $BASEDIR/build
1895 rm -rf $BASEDIR/cdrom
f9315063 1896 rm -rf $BASEDIR/packages
ebaecf2c 1897 rm -rf $BASEDIR/log
6c4cc7ea
MT
1898 if [ -h "${TOOLS_DIR}" ]; then
1899 rm -f "${TOOLS_DIR}"
df5e82b3 1900 fi
b307417f 1901 rm -f $BASEDIR/ipfire-*
f9783277 1902 print_status DONE
df5e82b3 1903 ;;
4e432799
MT
1904docker)
1905 # Build the docker image if it does not exist, yet
1906 if ! docker images -a | grep -q ^ipfire-builder; then
1907 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1908 print_status DONE
1909 else
1910 print_status FAIL
1911 exit 1
1912 fi
1913 fi
1914
1915 # Run the container and enter a shell
1916 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1917 ;;
c3db995c 1918downloadsrc)
df5e82b3
MT
1919 if [ ! -d $BASEDIR/cache ]; then
1920 mkdir $BASEDIR/cache
1921 fi
ebaecf2c 1922 mkdir -p $BASEDIR/log
857d9bf2 1923 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1924 FINISHED=0
1925 cd $BASEDIR/lfs
1926 for c in `seq $MAX_RETRIES`; do
2f8ae1c2 1927 if (( FINISHED==1 )); then
df5e82b3
MT
1928 break
1929 fi
1930 FINISHED=1
1931 cd $BASEDIR/lfs
1932 for i in *; do
1933 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1934 lfsmakecommoncheck ${i} || continue
1935
dc7d6b20 1936 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1937 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1938 if [ $? -ne 0 ]; then
f9783277 1939 print_status FAIL
df5e82b3
MT
1940 FINISHED=0
1941 else
1942 if [ $c -eq 1 ]; then
f9783277 1943 print_status DONE
df5e82b3
MT
1944 fi
1945 fi
1946 fi
1947 done
1948 done
9a7e4d85 1949 echo -e "${BOLD}***Verifying BLAKE2 checksum${NORMAL}"
df5e82b3
MT
1950 ERROR=0
1951 for i in *; do
1952 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1953 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1954 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
9a7e4d85 1955 MESSAGE="$i\t " b2 >> $LOGFILE 2>&1
df5e82b3 1956 if [ $? -ne 0 ]; then
9a7e4d85 1957 echo -ne "BLAKE2 checksum difference in lfs/$i"
f9783277 1958 print_status FAIL
df5e82b3
MT
1959 ERROR=1
1960 fi
1961 fi
1962 done
1963 if [ $ERROR -eq 0 ]; then
9a7e4d85 1964 echo -ne "${BOLD}all files BLAKE2 checksum match${NORMAL}"
f9783277 1965 print_status DONE
e22c7973
MT
1966 else
1967 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1968 print_status FAIL
df5e82b3 1969 fi
e22c7973 1970 cd - >/dev/null 2>&1
df5e82b3 1971 ;;
df5e82b3
MT
1972toolchain)
1973 prepareenv
f3b7cf47 1974 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1975 buildtoolchain
f74072a2 1976 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1977 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
d66e6fa8
MT
1978 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1979 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
9a7e4d85
PM
1980 b2sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
1981 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.b2
df5e82b3
MT
1982 stdumount
1983 ;;
1984gettoolchain)
df5e82b3 1985 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1986 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
d66e6fa8 1987 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
5bd13f01 1988 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1989 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1990 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1991 cd $BASEDIR/cache/toolchains
9a7e4d85 1992 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.b2 >& /dev/null
712d859c 1993 if [ $? -ne 0 ]; then
dc7d6b20 1994 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1995 else
9a7e4d85
PM
1996 if [ "`b2sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.b2 | awk '{print $1}'`" ]; then
1997 echo "`date -u '+%b %e %T'`: toolchain BLAKE2 checksum ok" | tee -a $LOGFILE
712d859c 1998 else
9a7e4d85 1999 exiterror "$PACKAGE BLAKE2 checksum did not match, check downloaded package"
712d859c 2000 fi
40a4ea4c 2001 fi
712d859c
MT
2002 else
2003 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
2004 fi
2005 ;;
15679d9f 2006uploadsrc)
661d9388
CS
2007 if [ -z $IPFIRE_USER ]; then
2008 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 2009 print_status FAIL
661d9388
CS
2010 exit 1
2011 fi
ae23a606 2012
dbd455ef
MT
2013 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
2014
2015 rsync \
2016 --recursive \
2017 --update \
2018 --ignore-existing \
2019 --progress \
2020 --human-readable \
2021 --exclude="toolchains/" \
2022 "${BASEDIR}/cache/" \
2023 "${IPFIRE_USER}@${URL_SOURCE}"
661d9388 2024
15679d9f 2025 exit 0
0eab8e84 2026 ;;
bf7c473f 2027lang)
69a6ec55
MT
2028 echo -ne "Checking the translations for missing or obsolete strings..."
2029 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
2030 $BASEDIR/tools/sort_strings.pl en
2031 $BASEDIR/tools/sort_strings.pl de
2032 $BASEDIR/tools/sort_strings.pl fr
2033 $BASEDIR/tools/sort_strings.pl es
2034 $BASEDIR/tools/sort_strings.pl pl
2035 $BASEDIR/tools/sort_strings.pl ru
2036 $BASEDIR/tools/sort_strings.pl nl
2037 $BASEDIR/tools/sort_strings.pl tr
2038 $BASEDIR/tools/sort_strings.pl it
2039 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
2040 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
2041 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
2042 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
72c8478e 2043 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
69a6ec55
MT
2044 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
2045 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
2046 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
2047 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
2048 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 2049 print_status DONE
69a6ec55
MT
2050
2051 echo -ne "Updating language lists..."
2052 update_language_list ${BASEDIR}/src/installer/po
2053 update_language_list ${BASEDIR}/src/setup/po
f9783277 2054 print_status DONE
bf7c473f 2055 ;;
1fb7f56e
MT
2056update-contributors)
2057 update_contributors
2058 ;;
ba137dd8
MT
2059find-dependencies)
2060 shift
2061 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
2062 ;;
4edcd4b2
LAH
2063check-manualpages)
2064 echo "Checking the manual pages for broken links..."
2f8ae1c2 2065
4edcd4b2
LAH
2066 chmod 755 $BASEDIR/tools/check_manualpages.pl
2067 if $BASEDIR/tools/check_manualpages.pl; then
2068 print_status DONE
2069 else
2070 print_status FAIL
2071 fi
2072 ;;
6b8cff41 2073*)
5f8a1acf 2074 echo "Usage: $0 [OPTIONS] {build|check-manualpages|clean|docker|downloadsrc|find-dependencies|gettoolchain|lang|shell|toolchain|update-contributors|uploadsrc}"
6b8cff41
MT
2075 cat doc/make.sh-usage
2076 ;;
3ea75603 2077esac